/*********************************************************************************************************/
/**
 * sas_link plugin for CKEditor 3.x (fc.stuurman@hccnet.nl)
 * version:	 1.0
 * Released: On 2010-09-03
 */
/*********************************************************************************************************/

/*
* @example An iframe-based dialog with custom button handling logics.
*/
( function() {
    CKEDITOR.plugins.add( 'sas_link',
    {
        requires: [ 'iframedialog' ],
		lang : ['en', 'nl'], 
        init: function( editor )
        {
           var me = this;
           CKEDITOR.dialog.add( 'SasLinkDialog', function ()
           {
              return {
                 title : editor.lang.sas_link.title,
                 minWidth : 350,
                 minHeight : 450,
                 contents : [
							{
							 id : 'iframe',
							 label : editor.lang.sas_link.title,
							 expand : true,
							 elements :
								   [
									  {
									   type : 'html',
									   id : 'pageMediaEmbed',
									   label : editor.lang.sas_link.title,
									   style : 'width : 100%;',
									   html : '<iframe src="'+me.path+'/dialogs/sas_link.php" frameborder="0" name="iframeMediaEmbed" id="iframeMediaEmbed" allowtransparency="1" style="width:100%;height:540px;margin:0;padding:0;"></iframe>'
									  }
								   ]
							}
					],
					buttons: [
								CKEDITOR.dialog.cancelButton
							]
              };
           } );

            editor.addCommand( 'sas_link', new CKEDITOR.dialogCommand( 'SasLinkDialog' ) );

            editor.ui.addButton( 'sas_link',
            {
                label: editor.lang.sas_link.title,
                command: 'sas_link',
                icon: this.path + 'sas_link.gif'
            } );
        }
    } );
} )();
